﻿# 项目设计报告: 
描述
## 1. 目录
- [1. 目录](#1-目录)
- [2. 背景意义](#2-背景意义)
  - [2.1.研究意义](#21-研究意义)
  - [2.2.赛题分析](#22-赛题分析)
- [3. 相关调研](#3-相关调研)
  - [3.1.ebpf](#31-ebpf)
- [4. 技术方案](#4-技术方案)
  - [4.1.系统设计](#41-系统设计)
  - [4.2. 模块设计](#42-模块设计)
- [5. 测试分析](#5-测试分析)
- [6. 安装部署](#6-安装部署)
  - [6.1.目录结构](#61-目录结构)
  - [6.2.文件描述](#62-文件描述)
- [7. 总结展望](#7-总结展望)
- [8. 附录](#8-附录)
## 2. 背景意义
### 2.1. 研究意义
在当今的云计算和容器化环境中，eBPF（extended Berkeley Packet Filter）技术的应用日益广泛，特别是在加速网络转发、提高系统性能方面展现出了巨大的潜力。使用eBPF加速raft集群的现实意义不仅体现在提升网络效率上，还包括增强系统安全性、降低运维成本等多个方面。下面将深入探讨使用eBPF加速raft集群的现实意义： 
#### 2.1.1.提升网络效率

- 降低延迟

   通过绕过复杂的内核栈，eBPF能够显著降低网络通信的延迟。
<br>

- 提高吞吐量

   eBPF通过优化数据路径，提高了网络吞吐量，使得数据传输更加高效。
<br>

- 减少CPU负载

   传统的网络栈处理需要占用大量的CPU资源，eBPF通过简化数据处理流程，减轻了CPU的负担。
<br>

#### 2.1.2.增强系统安全性

- 内核级别的安全防护

  eBPF运行在内核空间，可以实施更为严格和细粒度的安全策略。
<br>

- 动态安全监控

   利用eBPF可以实现实时的网络安全监控，及时发现并阻止潜在的攻击行为。
<br>

- 减少安全漏洞

   eBPF程序的执行是受限的，这减少了因程序错误导致的安全漏洞的风险。
<br>

#### 2.1.3.降低运维成本

- 简化网络配置

  eBPF可以自动分析和优化网络通信，减少了手动配置网络的复杂性和出错率。
<br>

- 自动化故障排除
       
   eBPF程序可以自动检测和修复一些常见的网络问题，减少了运维人员的工作量。
<br>

- 持续的性能优化

   eBPF程序可以根据系统的实际运行情况动态调整，实现持续的性能优化。
<br>

#### 2.1.4.提升应用性能

- 支持高并发

  eBPF的效率优势使得服务器能够支持更高的并发连接数，满足大规模用户访问的需求。
<br>

- 优化资源分配

  eBPF可以帮助更合理地分配系统资源，确保关键应用的性能需求得到满足。
<br>

#### 2.1.5.提高资源利用率

- 更高效的数据处理

  eBPF通过优化数据路径，提高了数据处理的效率，从而提升了资源利用率。
<br>

- 减少能耗

  降低CPU负载和网络延迟不仅提升了性能，也有助于减少整个系统的能耗。
<br>

- 优化硬件使用

   eBPF可以使硬件资源得到更有效的利用，延长硬件的使用寿命。
<br>

### 2.2. 赛题分析
本次作品要求要在集群中实现eBPF技术，以加速raft集群的运行。参考顶级会议论文eBPF对paxos协议的修改，本项目使用现有的eBPF技术对现有的raft开源程序dragonboat进行修改。

## 3. 相关调研
### 3.1. ebpf
eBPF是一项革命性的技术，可以在Linux内核中运行沙盒程序，而无需更改内核源代码或加载内核模块。通过使Linux内核可编程，基础架构软件可以利用现有的层，从而使它们更加智能和功能丰富，而无需继续为系统增加额外的复杂性层。
- 优点：低开销

   eBPF 是一个非常轻量级的工具，用于监控使用 Linux 内核运行的任何东西。虽然 eBPF 程序位于内核中，但它不会更改任何源代码，这使其成为泄露监控数据和调试的绝佳伴侣。eBPF 擅长的是跨复杂系统实现无客户端监控。 
<br>

- 优点：安全

  解决内核观测行的一种方法是使用内核模块，它带来了大量的安全问题。而eBPF 程序不会改变内核，所以您可以保留代码级更改的访问管理规则。此外，eBPF 程序有一个验证阶段，该阶段通过大量程序约束防止资源被过度使用，保障了运行的ebpf程序不会在内核产生安全问题。
<br>

- 优点：精细监控、跟踪

  eBPF 程序能提供比其他方式更精准、更细粒度的细节和内核上下文的监控和跟踪标准。并且eBPF监控、跟踪到的数据可以很容易地导出到用户空间，并由可观测平台进行可视化。 
<br>

- 缺点：很新

  eBPF 仅在较新版本的 Linux 内核上可用，这对于在版本更新方面稍有滞后的组织来说可能是令人望而却步的。如果您没有使用较新版本的 Linux 内核，那么 eBPF 根本不适合您。
原始的eBPF程序编写是非常繁琐和困难的。为了改变这一现状，llvm于2015年推出了可以将由高级语言编写的代码编译为eBPF字节码的功能，同时，其将 bpf()
等原始的系统调用进行了初步地封装，给出了 libbpf 库。这些库会包含将字节码加载到内核中的函数以及一些其他的关键函数。在Linux的源码包的 samples/bpf/ 目录下，有大量Linux提供的基于 libbpf 的eBPF样例代码。一个典型的基于 libbpf 的eBPF程序具有 `*_kern.c` 和 `*_user.c` 两个文件，
`*_kern.c` 中书写在内核中的挂载点以及处理函数， `*_user.c` 中书写用户态代码，完成内核态代码注入以及与用户交互的各种任务。
更为详细的教程可以参考[该视频](https://www.bilibili.com/video/BV1f54y1h74r?spm_id_from=333.999.0.0)。
然而由于该方法仍然较难理解且入门存在一定的难度，因此现阶段的eBPF程序开发大多基于一些工具，比如：
- `BCC`
- `BPFtrace`
- `libbpf`
- `go-libbpf`

## 4. 技术方案
### 4.1. 系统设计
主要通过ebpf进行修改的是三个部分：TC中的消息广播 、XDP中的快速确认、TC + XDP 中的 Wait-on-Quorums。
电极实现修改内容的的主要架构，六个ebpf程序
1. tc_broadcast_and_quorum：此程序拦截传出的准备消息。它实现了消息广播机制（4.1）和清单1中定量等待（4.3）的tc_ebpf函数
2. xdp_dispatcher：此程序将检查传入消息的类型，并调用相应的消息处理程序，它仅拦截ACK（仅在领导节点上接收）和准备（仅在跟随节点上接收）消息，并调用相应的handle_ACK和handle_preparation程序。
3. handle_ACK：xdp_ebpf函数，主要用于实现wait-onquorums部分的功能，它会丢弃大多数 ACK  消息，而仅将达到法定数量的 ACK  消息转发给用户空间应用程序。
4. handle_preparation：检测非关键路径的情况，检查到时，将消息转发到用户空间的应用程序。在正常情况下（大多数情 况下），它将调用write_buffer以开始fast_ACK。
5. write_buffer：此程序将消息/数据包数据存储到内核日志中，供用户空间应用程序进行轮询和使用。如前所述，主要使用eBPF环缓冲区实现日志数据结构，然后，该程序调用fast_ACK程序
6. fast_ACK：重用并修改接收到的包缓冲区，以创建一个ACK包并将其发送出去
   ![Alt img1](img/1.png)
### 4.2. 模块设计
#### 4.2.1.消息广播
- 在Paxos中使用广泛

  Leader节点向follower节点发送prepare消息，及leader节点向follower节点发送commit消息。
<br>

- 当前实现方法存在性能缺陷

  从用户空间向不同地址多次发送相同的报文，其overhead随follower的增加而增加，而每个follower节点的overhead不变。经典的leader瓶颈问题。IP多播方式则需要硬件和软件支持。
<br>

- 实现方式

  使用eBPF的TC hook，使用helper函数bpf_clone_redirect()在内核中复制报文包，更改其目的地址并分别发送。

![Alt img2](img/2.png)

#### 4.2.2.快速确认
Paxos中的请求延迟主要来源之一，
- 实现方式

  在follower节点中将送达的prepare报文缓存在内核日志中，由用户空间应用异步轮询
内核日志由BPF_MAP_TYPE_RINGBUF这个ebpf map数据结构实现，具有很高的效率

![Alt img3](img/3.png)
![Alt img4](img/4.png)
![Alt img5](img/5.png)

#### 4.2.3.定量等待
- Paxos中的关键路径

  Leader节点需要保证绝大多数follower节点都已经有当前请求的副本，才能执行commit完成请求。
<br>

- 当前实现方法存在性能缺陷

  在用户空间中收集所有follower节点的ACK信息，进行计数。有大量报文不被需要却占用了leader节点的CPU
<br>

- 实现方式

  用eBPF将定量等待转移到内核，存留一个比特数组用于记录信息，当达到定量时才将消息传递到用户态应用。在TC钩上清除比特位，在XDP钩上置位。

![Alt img6](img/6.png)

## 5. 测试分析
本项目当前通过龙舟示例程序helloworld作为测试分析程序，后期研究过程会开发专门的测试用例程序以更好的比较性能差异

## 6. 目录结构
本仓库的主要目录结构如下所示：

  ├─README.md  
  ├─img  
  │  ├─1.png  
  │  ├─2.png  
  │  ├─3.png  
  │  ├─4.png  
  │  ├─5.png  
  │  └─6.png  
  ├─src  
  │  ├─dragonboat  
  │  ├─dragonboat-example  
  │  ├─Electrode-main  
  │  └─xdp  
  ├─xdp内容解析.pdf    
  ├─电极源码分析.pdf  
  └─龙舟示例代码分析.pdf 



## 7. 总结展望

## 8. 附录

