电极

这是使用 eBPF 加速多 Paxos 协议的一种实现，如论文[“电极：加速分布式
与 eBPF 的协议“](https://www.usenix.org/system/files/nsdi23-zhou.pdf)来自 NSDI 2023。

目录

此存储库主要包含两个部分：

1.在“VR/”中实现 VR（Viewstapped Replication）协议，代码来自[推测性 Paxos](https://github.com/UWSysLab/specpaxos). 我们做了一些修改来实现我们的功能。 2.在 eBPF 中实现这三个优化，您可以在“xdp handler/”中找到代码。结构来自[BMC]的源代码(https://github.com/Orange-OpenSource/bmc-cache).

##建筑和运行

我们在[Cloudlab]中进行了实验(https://cloudlab.us/)通过使用“原始pc”型机器“xl170”。初始磁盘映像为“UBUNTU20-64-STD”。

因为我们使用的是内核版本“5.8.0”，所以我们应该手动更新：

wgethttps://raw.githubusercontent.com/pimlie/ubuntu-mainline-kernel.sh/master/ubuntu-mainline-kernel.sh
sudo bash ubuntu-mainine-kernel.sh-i 5.8.0
sudo 重新启动

您可以在重新启动之前通过“uname-r”检查内核版本，结果为“5.4.0-100-generic”。重新启动后，结果为“5.8.0-050800-generic”。

然后安装依赖项。

sudo apt 更新
sudo apt 安装 llvm clang gpg curl tar xz utils make gcc flex bison libssl dev libelf dev protobuf 编译器 pkg 配置 libunfold dev libssl devl libprotobuf dev libevent dev lib gtest dev

然后我们应该构建“xdp”模块，在这里我们应该运行[BMC 项目]中的脚本“kernel src download.sh”和“kernel src-prepare.sh”(https://www.usenix.org/conference/nsdi21/presentation/ghigoff). 我们做了一些修改以支持“5.8.0”。

bash 内核-src 下载.sh
bash kernel-src-prepare.sh

然后您应该能够编译代码：

1.在`/xdp处理程序/`，运行`make-clean`和`make`。 2.在`./`中，运行“make clean”和“make PARANOID=0”。

在我们的实验中，我们禁用了 NIC 中的自适应批处理和 irqbalance：

sudo ifconfig ens1f1np1 mtu 3000 以上
sudo ethtool-C ens1f1np1 自适应 rx 关闭自适应 tx 关闭 rx 帧 1 rx 使用 0 tx 帧 1 tx 使用 0
sudo ethtool-C ens1f1np1 自适应 rx 关闭自适应 tx 关闭 rx 帧 1 rx 使用 0 tx 帧 1 tx 使用 0
sudo ethtool-L ens1f1np1 组合 1
sudo 服务 irqbalance 停止
（设 CPU=0；cd/sys/class/net/ens1f1np1/device/msi_irqs/；
对于 IRQ，单位为\*；做
echo$CPU|sudo tee/proc/irq/$irq/smp_affinity_list
完成）

然后，您需要创建一个配置文件，如（例如“./config.txt'”）

f<可容忍的故障数>
复制副本＜主机名＞：＜端口＞
复制副本＜主机名＞：＜端口＞
...

因为在“TC_BROADCAST”优化中，我们需要分配目标服务器的 mac 地址，所以您应该在“xdp handler/fast_user.c”的第 281 行中写入集群的 MACADDR。此外，您还需要修改“xdp handler/fast_common.h”的第 17 行，“CLUSTER_SIZE”应等于$2f+1$。

然后你就可以运行代码了。因为我们的优化是独立的，这意味着您可以指定要添加的优化，所以我们在构建项目时通过定义变量来控制这一点。三个优化是：`TC_BROADCAST`、`FAST_QUORUM_PRUNE`和`FAST_REPLY`。

在“xdp handler/”中重新编译 eBPF 代码：

make clean&&make EXTRA_CFLAGS=“-DTC_BROADCAST-DFAST_QUORUM_PRUNE-DFAST_REPLY”

重新编译副本代码：

make clean&&make CXXFLAGS=“-DTC_BROADCAST-DFAST_QUORUM_PRUNE-DFAST_REPLY”

在“xdp handler/”中运行 eBPF 代码：

苏多/快速 ens1f1np1

在不同的复制副本计算机上运行复制副本 idx（例如，当“f”=1 时为 0、1 和 2）：

sudo 任务集-c1/工作台/副本-c 配置.txt-m vr-i｛idx｝

然后在单独的客户端机器上运行客户端，n 是请求数（您也可以用“-w”指定预热，用“-t”指定客户端数）：

./bench/client-c config.txt-m vr-n 10000

在客户端运行结束时，您可以获得运行时间（可用于计算吞吐量）和延迟。

**注意：**我们的代码目前不处理非关键路径情况，如数据包丢失/重新排序（我们在 Cloudlab 机器中没有观察到）、机器故障和网络故障。

##引用此作品
BibTex：

@在过程{周 2023 电极，
title ＝{{电极：用eBPF加速分布式协议}}，
作者={周，杨与王，泽州与达拉尼普拉加达，索米亚与余，敏兰}，
booktitle ＝{第 20 届 USENIX 网络系统设计与实现研讨会（NSDI 23）}，
pages ＝{1391-1407}，
年份=｛2023｝
}
