#推测性帕克索斯

这是推测性 Paxos 协议的一个实现，如
在论文中描述
[“在数据中心网络中使用近似同步设计分布式系统”](https://drkp.net/papers/specpaxos-nsdi15.pdf)
来自 NSDI 2015。

推测性 Paxos 是一种基于的状态机复制协议
分布式系统与数据中心协同设计的思想
网络。它在以下环境中提供出色的性能
副本以相同的顺序接收大多数请求。NSDI 论文
描述了如何实现“多数有序多播”（MOM）
以高概率提供此属性的基元。

在这些环境中，推测性 Paxos 能够完成
没有协调的操作。这使其能够实现
理论最小延迟（从客户端到副本的往返行程）
和高吞吐量，因为复制副本不需要在中交换消息
正常情况下。

目录

此存储库包含 3 个复制协议的实现：

1.推测性 Paxos，包括正常操作、同步和
协调协议。

2.Viewstapped Replication（VR），又名 Multi-Paxos，如中所述
纸张
[“Viewstapped Replication Revisited”](http://pmg.csail.mit.edu/papers/vr-revisited.pdf),
包括可选的批处理优化

3.快速 Paxos，尽管只实现了正常情况。

4.一个简单的未复制的 RPC 协议用于比较

…以及三个应用程序：

1.一个“null RPC”基准测试，它以最快的速度执行操作
可能的

2.一个简单的时间戳服务器，可能用于分布式
存储系统

3.一个事务性键值存储（“nistore”），支持
使用任意一个严格的多版本控制和并发控制
两阶段锁定或乐观并发控制。（这是
源自中使用的代码库
[TAPIR](http://syslab.cs.washington.edu/research/tapir/)
项目

##建筑和运行

推测性 Paxos 和应用程序可以使用“make”构建。它
已经在 Ubuntu 14.04、16.04 和 Debian 8 上进行了测试。回归测试
可以使用`make check运行`

依赖项包括（Debian/Uubuntu 包）：
protobuf 编译器 pkg 配置 libunvel-dev libssl dev libprotobuf dev libevent dev libgtest dev

您需要创建一个包含以下内容的配置文件
语法：

```
f<可容忍的故障数>
复制副本＜主机名＞：＜端口＞
复制副本＜主机名＞：＜端口＞
...
```

然后可以使用“”启动复制副本/bench/replica-c<配置文件的路径>-i<副本编号>-m<模式>，其中“模式”为： -推测性帕克索斯的“spec”
-“vr”用于 Viewstapped 复制
-“fastpaxos”表示 Fast Paxos
-“未复制”表示无复制（仅使用第一个副本）

“vr”模式还接受“-b”选项来指定最大批次
大小

要运行单个客户端，请使用`/bench/replica-c＜配置文件的路径＞
-m<mode>`。

对于性能测量，您可能需要添加`-DNASSERT`
和“-O2”到 Makefile 中的“CFLAGS”，并运行“make PARANOID=0”，
这禁用了改变复杂性的断言。

联系

推测性帕克索斯是
【UW 系统实验室】(http://syslab.cs.washington.edu/). 请给 Dan 发电子邮件
端口位于drkp@cs.washington.edu有任何问题。
