

#ifndef _FAST_COMMON_H
#define _FAST_COMMON_H

#define ETH_ALEN	6		

#define CLUSTER_SIZE 3 
#define FAST_REPLICA_MAX 100 
#define NONFRAG_MAGIC 0x20050318
#define FRAG_MAGIC 0x20101010


#define MAGIC_LEN 4
#define REQUEST_TYPE_LEN 33
#define PREPARE_TYPE_LEN 33
#define PREPAREOK_TYPE_LEN 35
#define MYPREPAREOK_TYPE_LEN 24

#define FAST_PAXOS_DATA_LEN 12
#define BROADCAST_SIGN_BIT (1<<31)
#define QUORUM_SIZE ((CLUSTER_SIZE + 1) >> 1)
#define QUORUM_BITSET_ENTRY 1024 // 2的次方


enum ReplicaStatus {
    STATUS_NORMAL,
    STATUS_VIEW_CHANGE,
    STATUS_RECOVERING
};



enum {
	FAST_PROG_XDP_HANDLE_PREPARE = 0,
	FAST_PROG_XDP_HANDLE_REQUEST,
	FAST_PROG_XDP_HANDLE_PREPAREOK,
    FAST_PROG_XDP_WRITE_BUFFER,
	FAST_PROG_XDP_PREPARE_REPLY,

	FAST_PROG_XDP_MAX
};

enum {
	FAST_PROG_TC_BROADCAST = 0,

	FAST_PROG_TC_MAX
};

struct paxos_configure {
	__u32 addr; // ipv4地址
	__u16 port;
	char eth[ETH_ALEN];
};

#endif
